; ##############################################################################
; ##############################################################################

.686
.model flat, stdcall
option casemap :none

; ##############################################################################
; ##############################################################################

.nolist
.nocref
include windows.inc

include user32.inc
include kernel32.inc
include gdi32.inc
include mapi32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib mapi32.lib

; ##############################################################################
; ##############################################################################

includelib Reshape.lib

TakeShape       PROTO :DWORD, :DWORD, :DWORD

include equates.inc
include struct.inc
include const.inc
include data.inc

include proto.inc
include c:\dev\asm\include\macro.inc

; ##############################################################################
; ##############################################################################

;.stack 4096

; ##############################################################################
; ##############################################################################

.code

; ##############################################################################
; ##############################################################################

Start:
;; =============================================================================
;;                             General Startup
;; -----------------------------------------------------------------------------
  invoke GetModuleHandle, NULL
  mov App.hInstance, eax
  mov frmMain.wc.hInstance, eax

  mov App.Heap, mCall(GetProcessHeap)

  .if mCall(LoadCursor, NULL, IDC_ARROW) != NULL
    mov frmMain.wc.hCursor, eax ; system cursor
  .else
    mGetLastError "Error loading system cursor", "LoadCursor Error"
  .endif
;; =============================================================================


;; =============================================================================
;;                             Register Form(s)
;; -----------------------------------------------------------------------------
  .if mCall(RegisterClassEx, addr frmMain.wc) == NULL
    mGetLastError "Error processing call to RegisterClassEx for frmMain.wc", "RegisterClassEx Error"
  .endif
;; =============================================================================


;; =============================================================================
;;                             Center Main Form
;; -----------------------------------------------------------------------------
  mov App.ScreenWidth, mCall(GetSystemMetrics, SM_CXSCREEN) ; get screen width in pixels
  mov frmMain.Wtx, mCall(TopXY, frmMain.Wwd, eax)

  mov App.ScreenHeight, mCall(GetSystemMetrics, SM_CYSCREEN) ; get screen height in pixels
  mov frmMain.Wty, mCall(TopXY, frmMain.Wht, eax)
;; =============================================================================


;; =============================================================================
;;                             Create Main Form
;; -----------------------------------------------------------------------------
  invoke CreateWindowEx, NULL, addr clsMainForm, sz("Request for Document Retrieval"), WS_POPUP or WS_VISIBLE, ;;WS_OVERLAPPEDWINDOW or 
        frmMain.Wtx, frmMain.Wty, frmMain.Wwd, frmMain.Wht, NULL, NULL, App.hInstance, NULL
  .if eax == NULL
    mGetLastError "Error creating main window", "CreateWindowEx Error"
  .else
    mov frmMain.hWnd, eax
  .endif
;; =============================================================================


@@:
  invoke GetMessage, addr msg, NULL, 0, 0  ; get each message
  test eax, eax                       ; Test for Zero Flag
  jz short @F                         ; Check Zero Flag, if Zero, then Exit
  invoke TranslateMessage, addr msg   ; translate it
  invoke DispatchMessage, addr msg    ; send it to message proc
  jmp short @B
@@:


  invoke ExitProcess, msg.wParam

; ##############################################################################
; ##############################################################################

include debug.inc
include misc.inc
include wndproc.inc

include docret.inc

END Start
