wpMain PROC hWin :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD
  .IF uMsg == WM_CREATE
    mov hbmBackground, mCall(LoadBitmap, App.hInstance, sz("IDB_BACKGROUND"))
    INVOKE GetObject, hbmBackground, SIZEOF(BITMAP), ADDR bmBackground
    
    ;; Create Send button
    mov frmMain.btnSend, mODButton("Send", 300, 200, 125, 75, eqWM_BTN_SEND)
    INVOKE TakeShape, frmMain.btnSend, mCall(LoadBitmap, App.hInstance, sz("IDB_BUTTONUP")), 00FFFFFFh
    mov frmMain.btnSendUp, mCall(LoadBitmap, App.hInstance, sz("IDB_BUTTONUP"))
    mov frmMain.btnSendDn, mCall(LoadBitmap, App.hInstance, sz("IDB_BUTTONDN"))
    mov frmMain.btnSendWp, mCall(SetWindowLong, frmMain.btnSend, GWL_WNDPROC, ADDR wpButton)

    ;; Create Font(s)
    .IF mCall(CreateFontIndirect, addr fntTahoma) == NULL
      mGetLastError "Error creating Tahoma Font", "CreateFontIndirect Error"
    .ELSE
      mov hTahoma, eax
    .ENDIF

    ;; Create Notes Edit box
    mov frmMain.txtNotes.hWnd, mODEdit("Text Test", 300, 100, 300, 150)
    INVOKE PostMessage, frmMain.txtNotes.hWnd, WM_SETFONT, hTahoma, FALSE
    mov frmMain.txtNotes.bmOut, mCall(LoadBitmap, App.hInstance, sz("IDB_NOTESOUT"))
    mov frmMain.txtNotes.bmOutBrush, mCall(CreatePatternBrush, eax)
    mov frmMain.txtNotes.bmOver, mCall(LoadBitmap, App.hInstance, sz("IDB_NOTESOVER"))
    mov frmMain.txtNotes.bmOverBrush, mCall(CreatePatternBrush, eax)
    mov frmMain.txtNotes.bmClick, mCall(LoadBitmap, App.hInstance, sz("IDB_NOTESCLICK"))
    mov frmMain.txtNotes.bmClickBrush, mCall(CreatePatternBrush, eax)
    INVOKE TakeShape, frmMain.txtNotes.hWnd, mCall(LoadBitmap, App.hInstance, sz("IDB_NOTESOUT")), 00FFFFFFh
    ;;mov frmMain.txtNotes.hWndProc, mCall(SetWindowLong, frmMain.txtNotes.hWnd, GWL_WNDPROC, ADDR wpNotes)


;    INVOKE SendMessage, frmMain.txtNotes.hWnd, EM_GETRECT, NULL, ADDR NotesRect
    
;    mov NotesRect.top, 40
    
;    INVOKE SendMessage, frmMain.txtNotes.hWnd, EM_SETMARGINS, EC_LEFTMARGIN, 30


    ;; Reshape Main Form
    rdtsc
    push eax
    INVOKE TakeShape, hWin, mCall(LoadBitmap, App.hInstance, sz("IDB_MASK")), 00FFFFFFh
    rdtsc
    pop ecx
    sub eax, ecx
    invoke MsgDD, eax

  .ELSEIF uMsg == WM_PAINT
    mov hdcMainWindow, mCall(BeginPaint, hWin, ADDR psBackground)
    mov hdcBackground, mCall(CreateCompatibleDC, hdcMainWindow)
    INVOKE SelectObject, hdcBackground, hbmBackground
    INVOKE BitBlt, hdcMainWindow, 0, 0, bmBackground.bmWidth, bmBackground.bmHeight, hdcBackground, 0, 0, SRCCOPY
    INVOKE DeleteDC, hdcBackground
    INVOKE EndPaint, hWin, ADDR psBackground ;; EndPaint releases the device context returned by BeginPaint!
  .ELSEIF uMsg == WM_LBUTTONDOWN
    INVOKE ReleaseCapture
    INVOKE SendMessage, hWin, WM_NCLBUTTONDOWN, HTCAPTION, NULL
  .ELSEIF uMsg == WM_RBUTTONDOWN
    INVOKE SendMessage, hWin, WM_SYSCOMMAND, SC_MINIMIZE, NULL
  .ELSEIF uMsg == WM_MOUSEMOVE || uMsg == WM_NCMOUSEMOVE
    INVOKE CopyBitMap, frmMain.btnSend, frmMain.btnSendUp, 125, 75
  .ELSEIF uMsg == WM_CTLCOLOREDIT ;; EM_SETMARGINS 
    invoke SetBkMode, wParam, TRANSPARENT
    mov eax, frmMain.txtNotes.bmOutBrush
    ret
  .ELSEIF uMsg == WM_DESTROY

    INVOKE DeleteObject, hbmBackground
    INVOKE PostQuitMessage, NULL
    mRet 0
  .ENDIF
  INVOKE DefWindowProc, hWin, uMsg, wParam, lParam
  ret
wpMain ENDP

wpButton PROC hWin :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD
  .IF uMsg == WM_PAINT ;; Returns Zero
    INVOKE CopyBitMap, hWin, frmMain.btnSendUp, 125, 75
    xor eax, eax
  .ELSEIF uMsg == WM_MOUSEMOVE
    INVOKE CopyBitMap, hWin, frmMain.btnSendDn, 125, 75
  .ELSEIF uMsg == WM_LBUTTONUP
    INVOKE MsgDD, eax
  .ENDIF
  INVOKE DefWindowProc, hWin, uMsg, wParam, lParam
  ret
wpButton ENDP

wpNotes PROC hWin :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD
  LOCAL psNotes :PAINTSTRUCT
  LOCAL hDC     :DWORD
;  .IF uMsg == WM_NCPAINT ;; WM_ERASEBKGND
;    INVOKE CopyBitMap, hWin, frmMain.txtNotes.bmOut, 125, 75
;    mRet TRUE
;  .IF uMsg == WM_PAINT ;; Returns Zero
;    mov hDC, mCall(BeginPaint, hWin, ADDR psNotes)
;    
;    INVOKE CopyBitMap, hWin, frmMain.txtNotes.bmOut, 125, 75
;    inc mCall(SendMessage, frmMain.txtNotes.hWnd, WM_GETTEXTLENGTH, NULL, NULL)
;    
;    push ebx ;; Save ebx
;    mov ebx, eax ;; Save the necessary size for use in next SendMessage!
;    push mAlloc(eax)
;
;    invoke SendMessage, frmMain.txtNotes.hWnd, WM_GETTEXT, ebx, eax
;;    invoke MessageBox, NULL, [esp+8], NULL, MB_OK
;
;    pop eax
;    mFree(eax)
;    pop ebx ;; Restore ebx
;    
;    INVOKE EndPaint, hWin, ADDR psNotes
;    xor eax, eax
  .IF uMsg == WM_MOUSEMOVE
    INVOKE CopyBitMap, hWin, frmMain.txtNotes.bmOver, 125, 75
  .ELSEIF uMsg == WM_CTLCOLOREDIT ;; EM_SETMARGINS 
    invoke SetBkMode, wParam, TRANSPARENT
    mov eax, frmMain.txtNotes.bmOutBrush
    ret
  .ELSEIF uMsg == WM_RBUTTONDOWN

    inc mCall(SendMessage, frmMain.txtNotes.hWnd, WM_GETTEXTLENGTH, NULL, NULL)
    
    push ebx ;; Save ebx
    mov ebx, eax ;; Save the necessary size for use in next SendMessage!
    push mAlloc(eax)

    invoke SendMessage, frmMain.txtNotes.hWnd, WM_GETTEXT, ebx, eax
    invoke MessageBox, NULL, [esp+8], NULL, MB_OK

    pop eax
    mFree(eax)
    pop ebx ;; Restore ebx

  .ELSE
    INVOKE DefWindowProc, hWin, uMsg, wParam, lParam
  .ENDIF
  ret
wpNotes ENDP
